(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
  typeof define === 'func' && define.amd ? define(factory) :
  (global.remUtils = factory());
}(this, (function () { 'use strict';

  /**
   * Created by:tm  Date:2018/9/4
   */
  /**
   * @desc 函数防抖
   * @param func 函数
   * @param wait 延迟执行毫秒数
   * @param immediate true 表立即执行，false 表非立即执行
   */
  function debounce(func, wait, immediate) {
    var timeout = void 0;

    return function () {
      var context = this;
      // args = [].slice.call(arguments)
      var args = arguments;

      if (timeout) clearTimeout(timeout);
      if (immediate) {
        var callNow = !timeout;
        timeout = setTimeout(function () {
          timeout = null;
        }, wait);
        if (callNow) func.apply(context, args);
      } else {
        timeout = setTimeout(function () {
          func.apply(context, args);
        }, wait);
      }
    };
  }

  /**
   * Created by:tm  Date:2018/9/4
   */

  var index = {
    hello: function hello() {
      console.log('hello world!这是第一个npm 包');
    },

    debounce: debounce
  };

  return index;

})));
