/**
 * Created by:tm  Date:2018/9/4
 */
// import resolve from 'rollup-plugin-node-resolve';
import babel from 'rollup-plugin-babel'
import { uglify } from "rollup-plugin-uglify"
import commonjs from 'rollup-plugin-commonjs'

export default {
  input: 'src/index.js',
  output: {
    file: process.env.NODE_ENV === 'production' ? 'index.min.js' : 'index.js',
    format: 'umd',
    name: 'remUtils'
  },
  plugins: [
    // resolve(), // 寻找外部模块用
    commonjs({
      include: 'node_modules/**',
    }),
    babel({
      exclude: 'node_modules/**' // 只编译我们的源代码
    }),
    // 压缩代码
    (process.env.NODE_ENV === 'production' && uglify({
      compress: { drop_console: true }
    }))
  ]
}
