/**
 * Created by:tm  Date:2018/9/18
 */
const RULES = {
  // ANDROID: /(^| |\()(android)(;| |\/|$)/i,
  ANDROID: /Android/i,
  IOS: /iPhone|iPad|iPod/i,
  // IOS: /(^| |\()(iPhone|iPad|iPod)(;| |\/|$)/i,
  WEIXIN: /(^| )MicroMessenger( |\/|$)/i,
  QQ: /(^| )(QQ)( |\/|$)/i,
  QQBROWSER_HD: /iPad.*?(^| )(MQQBrowser)( |\/|$)/i,
  QQBROWSER: /(^| )(MQQBrowser)( |\/|$)/i
}

const clientHelper = (conf) => {
  let UA = window.navigator.userAgent
  let isIOS = RULES.IOS.test(UA)
  let isAndroid = RULES.ANDROID.test(UA)
  let isQQ = RULES.QQ.test(UA)
  let isWX = RULES.WEIXIN.test(UA)
  let os = isAndroid ? UA.match(RULES.ANDROID)[0].toLowerCase() : isIOS ? UA.match(RULES.IOS)[0].toLowerCase() : 'android'
  let isApp = false
  if (conf) {
    let app = UA.match(conf.reg)
    if (app) {
      isApp = app[0].toLowerCase()
    }
  }
  return {
    os,
    isApp,
    isIOS,
    isAndroid,
    isQQ,
    isWX
  }
}

export default clientHelper
