/**
 * Created by:tm  Date:2018/9/7
 */
/**
 * @desc 函数节流
 * @param func 函数
 * @param wait 延迟执行毫秒数
 */
const throttle = (func, wait) => {
  let timeout
  return function () {
    const context = this
    // args = [].slice.call(arguments)
    let args = arguments

    if (!timeout) {
      timeout = setTimeout(() => {
        timeout = null
        func.apply(context, args)
      }, wait)
    }
  }
}

export default throttle
