/**
 * Created by:tm  Date:2018/9/4
 */
import getUrlSearch from './url/getUrlSearch'
import debounce from './func/debounce'
import throttle from './func/throttle'
import getLocalItem from './locals/getLocalItem'
import setLocalItem from './locals/setLocalItem'
import clientHelper from './client/client'
import createIframe from './scheme/createIframe'
import getScheme from './scheme/getScheme'
import schemeHandle from './scheme/schemeHandle'

// polly
if (typeof Object.assign !== 'function') {
  // Must be writable: true, enumerable: false, configurable: true
  Object.defineProperty(Object, "assign", {
    value: function assign (target, varArgs) { // .length of function is 2
      'use strict';
      if (target == null) { // TypeError if undefined or null
        throw new TypeError('Cannot convert undefined or null to object');
      }

      var to = Object(target);

      for (var index = 1; index < arguments.length; index++) {
        var nextSource = arguments[index];

        if (nextSource != null) { // Skip over if undefined or null
          for (var nextKey in nextSource) {
            // Avoid bugs when hasOwnProperty is shadowed
            if (Object.prototype.hasOwnProperty.call(nextSource, nextKey)) {
              to[nextKey] = nextSource[nextKey];
            }
          }
        }
      }
      return to;
    },
    writable: true,
    configurable: true
  });
}

/**
 * 判断空对象
 */
const isEmptyObject = (e) => {
  let t = void 0
  for (t in e) if (e.hasOwnProperty(t)) return !1
  return !0
}

export default {
  // 获取url参数
  getUrlSearch,
  // 判断空对象
  isEmptyObject,
  // 防抖
  debounce,
  // 节流
  throttle,
  // 获取local
  getLocalItem,
  // 存储local
  setLocalItem,
  // 客户端信息
  clientHelper,
  // 创建iframe
  createIframe,
  // 配置scheme字段
  getScheme,
  // 调起app跳转
  schemeHandle
}
