/**
 * Created by:tm  Date:2018/9/18
 */
/**
 * 获取 localStorage 存储的数据，如果有缓存时间，就根据时间判断，没有直接返回
 * @param key
 * @param def
 * @returns {any}
 */

const getLocalItem = (key, def = {}) => {
  let o = localStorage.getItem(key)
  if (!o) {
    return def
  }
  // || (o._t && o._t < +new Date())
  if (/"_t":/.test(o)) {
    let { _t, _d } = JSON.parse(o)
    console.log(key, '缓存时间', new Date(_t), '过期', _t < +new Date())
    if (_t < +new Date()) {
      console.log('缓存过期')
      return def
    } else {
      console.log('使用缓存')
      return _d
    }
  } else {
    console.log('没有缓存时间')
    return JSON.parse(o || JSON.stringify(def))
  }
}

export default getLocalItem
