/**
 * Created by:tm  Date:2018/10/11
 */
import createIframe from './createIframe'

/**
 * 调用app方法
 * @param config
 * @returns {boolean}
 * @private
 */
const schemeHandle = (config) => {
  let UA = navigator.userAgent.toLowerCase()
  let schemeAdr = config.scheme_Adr
  // 没有schemeAdr 只做下载页跳转，进行导流
  if (!schemeAdr) {
    if (UA.match(/(iPhone|iPod|iPad);?/i)) {
      window.location.href = config.iosUrl || config.url
    } else {
      window.location.href = config.url
    }
    return false
  }
  // app内，直接执行方法
  if (UA.match(/(zymk|kmh|mht|aym|smh|asmh);?/i)) {
    window.location.href = schemeAdr
    return false
  }
  if (UA.match(/(iPhone|iPod|iPad);?/i)) {
    // 抛出schemes,打开app对应页面
    if (/MicroMessenger/i.test(UA) || /(^| )(QQ)( |\/|$)/i.test(UA)) {
      window.location.href = config.iosUrl ? (config.iosUrl + '?' + decodeURIComponent(schemeAdr.split('?')[1])) : config.url
    } else {
      window.location.href = schemeAdr
      // 由于部分ios中打开app后，WAP页面会被挂起，定时器不会被执行。因此可以做下优化：
      // WAP页重新被聚焦后，如果超过1s，认为APP被打开了，重新聚焦时就不必再跳转到APP下载页
      let startTime = Date.now()
      let delayTime = /safari/.test(UA) ? 3000 : 1000
      let timer = setInterval(function () {
        let endTime = Date.now()
        if (endTime - startTime > delayTime) {
          clearInterval(timer)
          window.location.href = config.iosUrl || config.url
        }
      }, 25)
    }
  } else {
    if (/MicroMessenger/i.test(UA)) {
      window.location.href = config.iosUrl ? (config.iosUrl + '?' + decodeURIComponent(schemeAdr.split('?')[1])) : config.url
    } else {
      createIframe(schemeAdr)
      // 延时跳转下载页
      setTimeout(function () {
        window.location.href = config.url
      }, 600)
    }
  }
}

export default schemeHandle
